原题地址:https://leetcode-cn.com/problems/intersection-of-two-arrays-ii/description/
 
给定两个数组,写一个方法来计算它们的交集。

例如:

给定 nums1 = [1, 2, 2, 1], nums2 = [2, 2], 返回 [2, 2].

注意:

  • 输出结果中每个元素出现的次数,应与元素在两个数组中出现的次数一致。
  • 我们可以不考虑输出结果的顺序。

跟进:

  • 如果给定的数组已经排好序呢?你将如何优化你的算法?
  • 如果 nums1 的大小比 nums2 小很多,哪种方法更优?
  • 如果nums2的元素存储在磁盘上,内存是有限的,你不能一次加载所有的元素到内存中,你该怎么办?

以上是原题

 
我们先按照常规思路解题,再逐步分析最后的集中特殊情况。
 
  思路:
  1、增加一个计数器,用来记录其中一个数组元素出现的次数。
  2、遍历另一个数组,如果该数组元素在计数器中有记录且记录的次数大于1,将该数字新增到结果数组中,同时计数器该数字记录的次数减1。
  实现代码如下:
     public int[] intersect(int[] nums1, int[] nums2) {
Map<Integer, Integer> counter = new HashMap<>(); //计数器,key为数组中的数字,value为该数字在数组中出现的次数
for (int i = 0; i < nums1.length; i++) {
int num = nums1[i];
if (counter.containsKey(num)) {
counter.put(num, counter.get(num) + 1);
} else {
counter.put(num, 1);
}
}
List<Integer> tempList = new ArrayList<>();
for (int i = 0; i < nums2.length; i++) {
int num = nums2[i];
if (counter.containsKey(num) && counter.get(num) > 0) {
counter.put(num, counter.get(num) - 1); //计数器中记录该数字的次数减1
tempList.add(num); //将该数字添加到list中
}
}
int[] result = new int[tempList.size()];
//为满足题目返回值类型,将list转换为int数组
for (int i = 0; i < result.length; i++) {
result[i] = tempList.get(i);
}
return result;
}

  OK,基本功能已经实现,下一步我们一起思考如何满足几个跟进问题:

  • 如果给定的数组已经排好序呢?你将如何优化你的算法?

  思路:因为两个数组都是有序的,那我们完全可以用两个指针c1和c2分别顺序扫描两个数组,得到两个数字m和n,有以下三种关系:

  1、m == n,则该数字是重复数字,将该数字添加到结果数组中,同时将两个指针分别后移一位。

  2、m > n,我们需要将c2指针后移一位。

  3、m < n,我们需要将c1指针后移一位。

  重复以上步骤,直到c1或c2其中一个指针已移动到数组末端。

  代码实现如下:

     public int[] intersect(int[] nums1, int[] nums2) {
int cur1 = 0, cur2 = 0; // 定义指针,指向数组开始位置
List<Integer> list = new ArrayList<>();
while (cur1 < nums1.length && cur2 < nums2.length) { // 循环结束条件:任何一个指针指向对应数组的末端
int num1 = nums1[cur1];
int num2 = nums2[cur2];
if (num1 == num2) { // 重复数字,加入结果列表中
list.add(num1);
cur1++;
cur2++;
} else if (num1 < num2) { // 将cur1指针后移一位,继续下一次比较
cur1++;
} else { // 将cur2指针后移一位,继续下一次比较
cur2++;
}
}
int[] result = new int[list.size()];
// 为满足题目返回值类型,将list转换为int数组
for (int i = 0; i < list.size(); i++) {
result[i] = list.get(i);
}
return result;
}
  • 如果 nums1 的大小比 nums2 小很多,哪种方法更优?
  我们来对比上述两种方法:
  假设nums1和nums2的长度为l1, l2。
 
  第一种:
    不考虑结尾转换int数组的循环,一共有两处循环:
    1、第一次循环nums1初始化计数器。
    2、第二次循环nums2与计数器中存储的数值作比较。
    无论如何,这两种循环都需要完全执行,实际循环次数为 l1 + l2。
 
  第二种:
    不考虑结尾转换int数组的循环,一共有一处循环:
    1、每次循环同时在nums1和nums2中取值对比,如果相等,同时移动两个指针,一个指针结束后,循环结束。因为 l1 比 l2 小很多,只需要执行完l1次循环即可,实际消耗时间远远小于第一种方法。
 
    最差的情况:最差的情况是nums1和nums2中完全没有一个重复数字,且nums1中的最后一个元素大于nums2的倒数第二个元素,nums2的最后一个元素大于nums1的倒数第二个元素,在这种情况下,第二种方法的循环也同样需要执行 l1 + l2次。
 
  因此,只有在极端情况下,两种方法效率大约相等,其他任何情况下,第二种方法是要优于第一种方法的。
 
  • 如果nums2的元素存储在磁盘上,内存是有限的,你不能一次加载所有的元素到内存中,你该怎么办?

  如果nums2的元素多到无法一次性加载到内存中,那我们应该:

  1、将nums1中的数字初始化计数器。

  2、使用缓冲流读取文件的一部分数据,计数器中有记录且记录的次数大于1,将该数字新增到结果数组中,计数器中该数字记录的次数减1,这样完成了这一部分数据的统计。

  3、接着再读取文件中下一部分数据,重复步骤2。

  

OK,以上是这个问题的一些想法,如果朋友们有更好的方式,欢迎留言交流哈~

  

两个数组的交集 II [ LeetCode - 350 ]的更多相关文章

  1. 【Leetcode】【简单】【350. 两个数组的交集 II】【JavaScript】

    题目描述 350. 两个数组的交集 II 给定两个数组,编写一个函数来计算它们的交集. 示例 1: 输入: nums1 = [1,2,2,1], nums2 = [2,2]输出: [2,2] 示例 2 ...

  2. 前端与算法 leetcode 350. 两个数组的交集 II

    目录 # 前端与算法 leetcode 350. 两个数组的交集 II 题目描述 概要 提示 解析 解法一:哈希表 解法二:双指针 解法三:暴力法 算法 # 前端与算法 leetcode 350. 两 ...

  3. Java实现 LeetCode 350 两个数组的交集 II(二)

    350. 两个数组的交集 II 给定两个数组,编写一个函数来计算它们的交集. 示例 1: 输入: nums1 = [1,2,2,1], nums2 = [2,2] 输出: [2,2] 示例 2: 输入 ...

  4. LeetCode初级算法之数组:350 两个数组的交集 II

    两个数组的交集 II 题目地址:https://leetcode-cn.com/problems/intersection-of-two-arrays-ii/ 给定两个数组,编写一个函数来计算它们的交 ...

  5. 6、两个数组的交集 II

    6.两个数组的交集 II 给定两个数组,编写一个函数来计算它们的交集. 示例 1: 输入: nums1 = [1,2,2,1], nums2 = [2,2] 输出: [2,2] 示例 2: 输入: n ...

  6. leecode刷题(6)-- 两个数组的交集II

    leecode刷题(6)-- 两个数组的交集II 两个数组的交集II 描述: 给定两个数组,编写一个函数来计算它们的交集. 示例: 输入: nums1 = [1,2,2,1], nums2 = [2, ...

  7. LeetCode 350: 两个数组的交集 II Intersection of Two Arrays II

    题目: 给定两个数组,编写一个函数来计算它们的交集. Given two arrays, write a function to compute their intersection. 示例 1: 输 ...

  8. 350 Intersection of Two Arrays II 两个数组的交集 II

    给定两个数组,写一个方法来计算它们的交集.例如:给定 nums1 = [1, 2, 2, 1], nums2 = [2, 2], 返回 [2, 2].注意:       输出结果中每个元素出现的次数, ...

  9. 【leetcode 简单】 第八十五题 两个数组的交集 II

    给定两个数组,编写一个函数来计算它们的交集. 示例 1: 输入: nums1 = [1,2,2,1], nums2 = [2,2] 输出: [2,2] 示例 2: 输入: nums1 = [4,9,5 ...

随机推荐

  1. HASH算法小结

    一.简述 HASH算法的本质是特征提取——将某种不太好表示的特征,通过某种压缩的方式映射成一个值.这样,就可以优雅解决一部分难以解决的特征统计问题. 同时考虑到hash算法的本质是个概率算法,因此并不 ...

  2. Java——Random类随机整数---18.10.11

    一.Random类的定义 1.Random类位于java.util包中,主要用于生成 伪随机数 2.random类将 种子数 作为随机算法的起源数字,计算生成伪随机数,其与生成的随机数字的区间无关 3 ...

  3. Java中的IO流体系

    Java为我们提供了多种多样的IO流,我们可以根据不同的功能及性能要求挑选合适的IO流,如图10-7所示,为Java中IO流类的体系. 注:这里只列出常用的类,详情可以参考JDK API文档.粗体标注 ...

  4. 基于jersey和Apache Tomcat构建Restful Web服务(二)

    基于jersey和Apache Tomcat构建Restful Web服务(二) 上篇博客介绍了REST以及Jersey并使用其搭建了一个简单的“Hello World”,那么本次呢,再来点有趣的东西 ...

  5. 【APUE】Chapter10 Signals

    Signal主要分两大部分: A. 什么是Signal,有哪些Signal,都是干什么使的. B. 列举了非常多不正确(不可靠)的处理Signal的方式,以及怎么样设计来避免这些错误出现. 10.2 ...

  6. 「日常训练」「小专题·USACO」 Wormholes(1-4)

    题意 之后补充. 分析 这是一条很好的考察递归(或者说搜索)的题目.它的两个过程(建立初步解,验证)都用到了递归(或者说运用递归可以相当程度的减少代码量). 具体实现见代码.注意,为了使用std::p ...

  7. 「日常训练」Phone Numbers (CFR466D2C)

    题意(Codeforces 940C) 给定一字符串,求比它字典序大的字符串.限定其长度,并且只能用原串的字母. 分析 考虑原串长度lorigin与给定的长度lgiven.若给定长度大于原串长度,直接 ...

  8. 护网杯 three hit 复现(is_numeric引发的二次注入)

    1.题目源码 https://github.com/ZhangAiQiang/three-hit 题目并不真的是当时源码,是我根据做法自己写的,虽然代码烂,但是还好能达到复现的目的 ,兄弟们star一 ...

  9. python 基础篇 14 程程器表达式 内置函数

    昨日内容回顾    可迭代对象:        内部含有__iter__方法的就是可迭代对象.        可迭代对象不能取值,因为内部不含有__next__方法.     可迭代对象 ---> ...

  10. Android之Audio和Video

    The Android platform offers built-in encoding/decoding for a variety of common media types, so that ...